import { LanguagesService } from '../../../../language/application';
import { StageModelService } from '../../services/stateService';
import { Query, ExecuteResult } from '../../../../query/domain';
import { SchemaFacade, QueryOptions } from 'lambdaorm-base';
import { Executor } from '../../../../execution/domain';
import { Helper } from '../../../../shared/application';
export declare abstract class StageActionDDL {
    protected readonly executor: Executor;
    protected readonly stageModelService: StageModelService;
    protected readonly schemaFacade: SchemaFacade;
    protected readonly languages: LanguagesService;
    protected readonly options: QueryOptions;
    protected readonly helper: Helper;
    constructor(executor: Executor, stageModelService: StageModelService, schemaFacade: SchemaFacade, languages: LanguagesService, options: QueryOptions, helper: Helper);
    abstract execute(): Promise<ExecuteResult[]>;
    abstract queries(): Promise<Query[]>;
    sentence(): Promise<any[]>;
}
