"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-template-curly-in-string */
const __1 = require("../../../..");
beforeAll(() => __awaiter(void 0, void 0, void 0, function* () {
    require('dotenv').config({ path: './config/northwind.env' });
    yield __1.orm.init('./config/northwind.yaml');
}));
describe('delete', () => {
    const context = JSON.parse('{}');
    test('normalize', () => {
        expect(__1.orm.normalize('Categories.delete()')).toStrictEqual('Categories.delete().filter(p=>(p.id==id))');
        expect(__1.orm.normalize('Categories.delete(entity)')).toStrictEqual('Categories.delete().filter(p=>(p.id==entity.id))');
        expect(__1.orm.normalize('Categories.delete(p => entity)')).toStrictEqual('Categories.delete().filter(p=>(p.id==entity.id))');
        expect(__1.orm.normalize('Categories.delete(p => p)')).toStrictEqual('Categories.delete().filter(p=>(p.id==id))');
        expect(__1.orm.normalize('Categories.delete().filter(p => p.id === id)')).toStrictEqual('Categories.delete().filter(p=>(p.id==id))');
        expect(__1.orm.normalize('Categories.delete().filter(p => p.id === entity.id)')).toStrictEqual('Categories.delete().filter(p=>(p.id==entity.id))');
        expect(__1.orm.normalize('Categories.deleteAll()')).toStrictEqual('Categories.delete()');
        expect(__1.orm.normalize('Categories.deleteAll().filter(p=> substring(p.name,1,3) === "cat")')).toStrictEqual('Categories.delete().filter(p=>(substring(p.name,1,3)==cat))');
        expect(__1.orm.normalize('Orders.details.delete().filter(p => p.orderId === id)')).toStrictEqual('Orders.details.delete().filter(p=>(p.orderId==id))');
        expect(__1.orm.normalize('Orders.delete().include(p => p.details)')).toStrictEqual('Orders.delete().filter(p=>(p.id==id)).include(p=>p.details.delete().filter(p=>((p.orderId==orderId)&&(p.productId==productId))))');
        expect(__1.orm.normalize('Orders.delete().filter(p => p.id === id).include(p => p.details)')).toStrictEqual('Orders.delete().filter(p=>(p.id==id)).include(p=>p.details.delete().filter(p=>((p.orderId==orderId)&&(p.productId==productId))))');
        expect(__1.orm.normalize('Orders.delete().include(p => p.details)')).toStrictEqual('Orders.delete().filter(p=>(p.id==id)).include(p=>p.details.delete().filter(p=>((p.orderId==orderId)&&(p.productId==productId))))');
        expect(__1.orm.normalize('Orders.details.delete(entity)')).toStrictEqual('Orders.details.delete().filter(p=>((p.orderId==entity.orderId)&&(p.productId==entity.productId)))');
        expect(__1.orm.normalize('Orders.delete(entity).include(p => p.details)')).toStrictEqual('Orders.delete().filter(p=>(p.id==entity.id)).include(p=>p.details.delete().filter(p=>((p.orderId==orderId)&&(p.productId==productId))))');
        expect(__1.orm.normalize('Orders.details.deleteAll()')).toStrictEqual('Orders.details.delete()');
    });
    test('model', () => {
        expect(__1.orm.model('Categories.delete()')).toStrictEqual([]);
        expect(__1.orm.model('Categories.delete(entity)')).toStrictEqual([]);
        expect(__1.orm.model('Categories.delete(p => entity)')).toStrictEqual([]);
        expect(__1.orm.model('Categories.delete(p => p)')).toStrictEqual([]);
        expect(__1.orm.model('Categories.delete().filter(p => p.id === id)')).toStrictEqual([]);
        expect(__1.orm.model('Categories.delete().filter(p => p.id === entity.id)')).toStrictEqual([]);
        expect(__1.orm.model('Categories.deleteAll()')).toStrictEqual([]);
        expect(__1.orm.model('Categories.deleteAll().filter(p=> substring(p.name,1,3) === "cat")')).toStrictEqual([]);
        expect(__1.orm.model('Orders.details.delete().filter(p => p.orderId === id)')).toStrictEqual([]);
        expect(__1.orm.model('Orders.delete().include(p => p.details)')).toStrictEqual([{ 'name': 'details', 'type': 'Orders.details[]', 'children': [] }]);
        expect(__1.orm.model('Orders.delete().filter(p => p.id === id).include(p => p.details)')).toStrictEqual([{ 'name': 'details', 'type': 'Orders.details[]', 'children': [] }]);
        expect(__1.orm.model('Orders.delete().include(p => p.details)')).toStrictEqual([{ 'name': 'details', 'type': 'Orders.details[]', 'children': [] }]);
        expect(__1.orm.model('Orders.details.delete(entity)')).toStrictEqual([]);
        expect(__1.orm.model('Orders.delete(entity).include(p => p.details)')).toStrictEqual([{ 'name': 'details', 'type': 'Orders.details[]', 'children': [] }]);
        expect(__1.orm.model('Orders.details.deleteAll()')).toStrictEqual([]);
    });
    test('parameters', () => {
        expect(__1.orm.parameters('Categories.delete()')).toStrictEqual([{ 'name': 'id', 'type': 'integer' }]);
        expect(__1.orm.parameters('Categories.delete(entity)')).toStrictEqual([{ 'name': 'entity.id', 'type': 'integer' }]);
        expect(__1.orm.parameters('Categories.delete(p => entity)')).toStrictEqual([{ 'name': 'entity.id', 'type': 'integer' }]);
        expect(__1.orm.parameters('Categories.delete(p => p)')).toStrictEqual([{ 'name': 'id', 'type': 'integer' }]);
        expect(__1.orm.parameters('Categories.delete().filter(p => p.id === id)')).toStrictEqual([{ 'name': 'id', 'type': 'integer' }]);
        expect(__1.orm.parameters('Categories.delete().filter(p => p.id === entity.id)')).toStrictEqual([{ 'name': 'entity.id', 'type': 'integer' }]);
        expect(__1.orm.parameters('Categories.deleteAll()')).toStrictEqual([]);
        expect(__1.orm.parameters('Categories.deleteAll().filter(p=> substring(p.name,1,3) === "cat")')).toStrictEqual([]);
        expect(__1.orm.parameters('Orders.details.delete().filter(p => p.orderId === id)')).toStrictEqual([{ 'name': 'id', 'type': 'integer' }]);
        expect(__1.orm.parameters('Orders.delete().include(p => p.details)')).toStrictEqual([{ 'name': 'id', 'type': 'integer' }, { 'name': 'details', 'type': 'Orders.details', 'children': [{ 'name': 'orderId', 'type': 'integer' }, { 'name': 'productId', 'type': 'integer' }] }]);
        expect(__1.orm.parameters('Orders.delete().filter(p => p.id === id).include(p => p.details)')).toStrictEqual([{ 'name': 'id', 'type': 'integer' }, { 'name': 'details', 'type': 'Orders.details', 'children': [{ 'name': 'orderId', 'type': 'integer' }, { 'name': 'productId', 'type': 'integer' }] }]);
        expect(__1.orm.parameters('Orders.delete().include(p => p.details)')).toStrictEqual([{ 'name': 'id', 'type': 'integer' }, { 'name': 'details', 'type': 'Orders.details', 'children': [{ 'name': 'orderId', 'type': 'integer' }, { 'name': 'productId', 'type': 'integer' }] }]);
        expect(__1.orm.parameters('Orders.details.delete(entity)')).toStrictEqual([{ 'name': 'entity.orderId', 'type': 'integer' }, { 'name': 'entity.productId', 'type': 'integer' }]);
        expect(__1.orm.parameters('Orders.delete(entity).include(p => p.details)')).toStrictEqual([{ 'name': 'entity.id', 'type': 'integer' }, { 'name': 'details', 'type': 'Orders.details', 'children': [{ 'name': 'orderId', 'type': 'integer' }, { 'name': 'productId', 'type': 'integer' }] }]);
        expect(__1.orm.parameters('Orders.details.deleteAll()')).toStrictEqual([]);
    });
    test('constraints', () => {
        expect(__1.orm.constraints('Categories.delete()')).toStrictEqual({ "entity": "Categories", "constraints": [] });
        expect(__1.orm.constraints('Categories.delete(entity)')).toStrictEqual({ "entity": "Categories", "constraints": [] });
        expect(__1.orm.constraints('Categories.delete(p => entity)')).toStrictEqual({ "entity": "Categories", "constraints": [] });
        expect(__1.orm.constraints('Categories.delete(p => p)')).toStrictEqual({ "entity": "Categories", "constraints": [] });
        expect(__1.orm.constraints('Categories.delete().filter(p => p.id === id)')).toStrictEqual({ "entity": "Categories", "constraints": [] });
        expect(__1.orm.constraints('Categories.delete().filter(p => p.id === entity.id)')).toStrictEqual({ "entity": "Categories", "constraints": [] });
        expect(__1.orm.constraints('Categories.deleteAll()')).toStrictEqual({ "entity": "Categories", "constraints": [] });
        expect(__1.orm.constraints('Categories.deleteAll().filter(p=> substring(p.name,1,3) === "cat")')).toStrictEqual({ "entity": "Categories", "constraints": [] });
        expect(__1.orm.constraints('Orders.details.delete().filter(p => p.orderId === id)')).toStrictEqual({ "entity": "Orders.details", "constraints": [] });
        expect(__1.orm.constraints('Orders.delete().include(p => p.details)')).toStrictEqual({ "entity": "Orders", "constraints": [], "children": [{ "entity": "Orders.details", "constraints": [{ "message": "Cannot be null property orderId in entity Orders.details", "condition": "isNotNull(orderId)" }, { "message": "Cannot be null property productId in entity Orders.details", "condition": "isNotNull(productId)" }] }] });
        expect(__1.orm.constraints('Orders.delete().filter(p => p.id === id).include(p => p.details)')).toStrictEqual({ "entity": "Orders", "constraints": [], "children": [{ "entity": "Orders.details", "constraints": [{ "message": "Cannot be null property orderId in entity Orders.details", "condition": "isNotNull(orderId)" }, { "message": "Cannot be null property productId in entity Orders.details", "condition": "isNotNull(productId)" }] }] });
        expect(__1.orm.constraints('Orders.delete().include(p => p.details)')).toStrictEqual({ "entity": "Orders", "constraints": [], "children": [{ "entity": "Orders.details", "constraints": [{ "message": "Cannot be null property orderId in entity Orders.details", "condition": "isNotNull(orderId)" }, { "message": "Cannot be null property productId in entity Orders.details", "condition": "isNotNull(productId)" }] }] });
        expect(__1.orm.constraints('Orders.details.delete(entity)')).toStrictEqual({ "entity": "Orders.details", "constraints": [] });
        expect(__1.orm.constraints('Orders.delete(entity).include(p => p.details)')).toStrictEqual({ "entity": "Orders", "constraints": [], "children": [{ "entity": "Orders.details", "constraints": [{ "message": "Cannot be null property orderId in entity Orders.details", "condition": "isNotNull(orderId)" }, { "message": "Cannot be null property productId in entity Orders.details", "condition": "isNotNull(productId)" }] }] });
        expect(__1.orm.constraints('Orders.details.deleteAll()')).toStrictEqual({ "entity": "Orders.details", "constraints": [] });
    });
    test('getInfo', () => {
        expect(__1.orm.plan('Categories.delete()', { stage: 'MySQL' })).toStrictEqual({ "entity": "Categories", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE c FROM Categories AS c WHERE c.CategoryID = ? " });
        expect(__1.orm.plan('Categories.delete(entity)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Categories", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE c FROM Categories AS c WHERE c.CategoryID = ? " });
        expect(__1.orm.plan('Categories.delete(p => entity)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Categories", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE c FROM Categories AS c WHERE c.CategoryID = ? " });
        expect(__1.orm.plan('Categories.delete(p => p)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Categories", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE c FROM Categories AS c WHERE c.CategoryID = ? " });
        expect(__1.orm.plan('Categories.delete().filter(p => p.id === id)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Categories", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE c FROM Categories AS c WHERE c.CategoryID = ? " });
        expect(__1.orm.plan('Categories.delete().filter(p => p.id === entity.id)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Categories", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE c FROM Categories AS c WHERE c.CategoryID = ? " });
        expect(__1.orm.plan('Categories.deleteAll()', { stage: 'MySQL' })).toStrictEqual({ "entity": "Categories", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE c FROM Categories AS c " });
        expect(__1.orm.plan('Categories.deleteAll().filter(p=> substring(p.name,1,3) === "cat")', { stage: 'MySQL' })).toStrictEqual({ "entity": "Categories", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE c FROM Categories AS c WHERE SUBSTR(c.CategoryName,1,3) = 'cat' " });
        expect(__1.orm.plan('Orders.details.delete().filter(p => p.orderId === id)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Orders.details", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o FROM `Order Details` AS o WHERE o.OrderID = ? " });
        expect(__1.orm.plan('Orders.delete().include(p => p.details)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Orders", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o FROM Orders AS o WHERE o.OrderID = ? ", "children": [{ "entity": "Orders.details", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o1 FROM `Order Details` AS o1 WHERE (o1.OrderID = ? AND o1.ProductID = ?) " }] });
        expect(__1.orm.plan('Orders.delete().filter(p => p.id === id).include(p => p.details)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Orders", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o FROM Orders AS o WHERE o.OrderID = ? ", "children": [{ "entity": "Orders.details", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o1 FROM `Order Details` AS o1 WHERE (o1.OrderID = ? AND o1.ProductID = ?) " }] });
        expect(__1.orm.plan('Orders.delete().include(p => p.details)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Orders", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o FROM Orders AS o WHERE o.OrderID = ? ", "children": [{ "entity": "Orders.details", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o1 FROM `Order Details` AS o1 WHERE (o1.OrderID = ? AND o1.ProductID = ?) " }] });
        expect(__1.orm.plan('Orders.details.delete(entity)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Orders.details", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o FROM `Order Details` AS o WHERE (o.OrderID = ? AND o.ProductID = ?) " });
        expect(__1.orm.plan('Orders.delete(entity).include(p => p.details)', { stage: 'MySQL' })).toStrictEqual({ "entity": "Orders", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o FROM Orders AS o WHERE o.OrderID = ? ", "children": [{ "entity": "Orders.details", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o1 FROM `Order Details` AS o1 WHERE (o1.OrderID = ? AND o1.ProductID = ?) " }] });
        expect(__1.orm.plan('Orders.details.deleteAll()', { stage: 'MySQL' })).toStrictEqual({ "entity": "Orders.details", "dialect": "MySQL", "source": "MySQL", "sentence": "DELETE o FROM `Order Details` AS o " });
    });
});
//# sourceMappingURL=delete.test.js.map